### Hierarchy

- AbstractVisitor
  - BaseVisitor
  - BaseVisitor
  - BaseVisitor

### Implements

- Visitor

## Index

### Constructors

- constructor

### Properties

- callbacks

### Methods

- setCallback
- triggerAllOperationsAfter
- triggerAllOperationsBefore
- triggerArgument
- triggerArgumentsAfter
- triggerArgumentsBefore
- triggerCallbacks
- triggerDocumentAfter
- triggerDocumentBefore
- triggerEnum
- triggerEnumValue
- triggerEnumValuesAfter
- triggerEnumValuesBefore
- triggerEnumsAfter
- triggerEnumsBefore
- triggerInterface
- triggerInterfaceAfter
- triggerInterfaceBefore
- triggerNamespace
- triggerObject
- triggerObjectAfter
- triggerObjectBefore
- triggerObjectField
- triggerObjectFieldsAfter
- triggerObjectFieldsBefore
- triggerObjectsAfter
- triggerObjectsBefore
- triggerOperation
- triggerOperationAfter
- triggerOperationBefore
- triggerOperationsAfter
- triggerOperationsBefore
- triggerRole
- triggerRoleAfter
- triggerRoleBefore
- triggerRolesAfter
- triggerRolesBefore
- visitAllOperationsAfter
- visitAllOperationsBefore
- visitArgument
- visitArgumentsAfter
- visitArgumentsBefore
- visitDocumentAfter
- visitDocumentBefore
- visitEnum
- visitEnumValue
- visitEnumValuesAfter
- visitEnumValuesBefore
- visitEnumsAfter
- visitEnumsBefore
- visitInterface
- visitInterfaceAfter
- visitInterfaceBefore
- visitNamespace
- visitObject
- visitObjectAfter
- visitObjectBefore
- visitObjectField
- visitObjectFieldsAfter
- visitObjectFieldsBefore
- visitObjectsAfter
- visitObjectsBefore
- visitOperation
- visitOperationAfter
- visitOperationBefore
- visitOperationsAfter
- visitOperationsBefore
- visitRole
- visitRoleAfter
- visitRoleBefore
- visitRolesAfter
- visitRolesBefore

## Constructors

### constructor

- new AbstractVisitor(): AbstractVisitor

- #### Returns AbstractVisitor

## Properties

### callbacks

callbacks: Callbacks = ...

- Defined in src/ast/visitor.ts:237

## Methods

### setCallback

- setCallback(phase: string, purpose: string, callback: VisitorCallback): void

- - Defined in src/ast/visitor.ts:239

  #### Parameters

  - ##### phase: string

  - ##### purpose: string

  - ##### callback: VisitorCallback

  #### Returns void

### triggerAllOperationsAfter

- triggerAllOperationsAfter(context: Context): void

- - Defined in src/ast/visitor.ts:376

  #### Parameters

  - ##### context: Context

  #### Returns void

### triggerAllOperationsBefore

- triggerAllOperationsBefore(context: Context): void

- - Defined in src/ast/visitor.ts:274

  #### Parameters

  - ##### context: Context

  #### Returns void

### triggerArgument

- triggerArgument(context: Context): void

- - Defined in src/ast/visitor.ts:334

  #### Parameters

  - ##### context: Context

  #### Returns void

### triggerArgumentsAfter

- triggerArgumentsAfter(context: Context): void

- - Defined in src/ast/visitor.ts:340

  #### Parameters

  - ##### context: Context

  #### Returns void

### triggerArgumentsBefore

- triggerArgumentsBefore(context: Context): void

- - Defined in src/ast/visitor.ts:328

  #### Parameters

  - ##### context: Context

  #### Returns void

### triggerCallbacks

- triggerCallbacks(context: Context, phase: string): void

- - Defined in src/ast/visitor.ts:248

  #### Parameters

  - ##### context: Context

  - ##### phase: string

  #### Returns void

### triggerDocumentAfter

- triggerDocumentAfter(context: Context): void

- - Defined in src/ast/visitor.ts:469

  #### Parameters

  - ##### context: Context

  #### Returns void

### triggerDocumentBefore

- triggerDocumentBefore(context: Context): void

- - Defined in src/ast/visitor.ts:261

  #### Parameters

  - ##### context: Context

  #### Returns void

### triggerEnum

- triggerEnum(context: Context): void

- - Defined in src/ast/visitor.ts:438

  #### Parameters

  - ##### context: Context

  #### Returns void

### triggerEnumValue

- triggerEnumValue(context: Context): void

- - Defined in src/ast/visitor.ts:450

  #### Parameters

  - ##### context: Context

  #### Returns void

### triggerEnumValuesAfter

- triggerEnumValuesAfter(context: Context): void

- - Defined in src/ast/visitor.ts:456

  #### Parameters

  - ##### context: Context

  #### Returns void

### triggerEnumValuesBefore

- triggerEnumValuesBefore(context: Context): void

- - Defined in src/ast/visitor.ts:444

  #### Parameters

  - ##### context: Context

  #### Returns void

### triggerEnumsAfter

- triggerEnumsAfter(context: Context): void

- - Defined in src/ast/visitor.ts:462

  #### Parameters

  - ##### context: Context

  #### Returns void

### triggerEnumsBefore

- triggerEnumsBefore(context: Context): void

- - Defined in src/ast/visitor.ts:432

  #### Parameters

  - ##### context: Context

  #### Returns void

### triggerInterface

- triggerInterface(context: Context): void

- - Defined in src/ast/visitor.ts:286

  #### Parameters

  - ##### context: Context

  #### Returns void

### triggerInterfaceAfter

- triggerInterfaceAfter(context: Context): void

- - Defined in src/ast/visitor.ts:358

  #### Parameters

  - ##### context: Context

  #### Returns void

### triggerInterfaceBefore

- triggerInterfaceBefore(context: Context): void

- - Defined in src/ast/visitor.ts:280

  #### Parameters

  - ##### context: Context

  #### Returns void

### triggerNamespace

- triggerNamespace(context: Context): void

- - Defined in src/ast/visitor.ts:267

  #### Parameters

  - ##### context: Context

  #### Returns void

### triggerObject

- triggerObject(context: Context): void

- - Defined in src/ast/visitor.ts:395

  #### Parameters

  - ##### context: Context

  #### Returns void

### triggerObjectAfter

- triggerObjectAfter(context: Context): void

- - Defined in src/ast/visitor.ts:419

  #### Parameters

  - ##### context: Context

  #### Returns void

### triggerObjectBefore

- triggerObjectBefore(context: Context): void

- - Defined in src/ast/visitor.ts:389

  #### Parameters

  - ##### context: Context

  #### Returns void

### triggerObjectField

- triggerObjectField(context: Context): void

- - Defined in src/ast/visitor.ts:407

  #### Parameters

  - ##### context: Context

  #### Returns void

### triggerObjectFieldsAfter

- triggerObjectFieldsAfter(context: Context): void

- - Defined in src/ast/visitor.ts:413

  #### Parameters

  - ##### context: Context

  #### Returns void

### triggerObjectFieldsBefore

- triggerObjectFieldsBefore(context: Context): void

- - Defined in src/ast/visitor.ts:401

  #### Parameters

  - ##### context: Context

  #### Returns void

### triggerObjectsAfter

- triggerObjectsAfter(context: Context): void

- - Defined in src/ast/visitor.ts:425

  #### Parameters

  - ##### context: Context

  #### Returns void

### triggerObjectsBefore

- triggerObjectsBefore(context: Context): void

- - Defined in src/ast/visitor.ts:383

  #### Parameters

  - ##### context: Context

  #### Returns void

### triggerOperation

- triggerOperation(context: Context): void

- - Defined in src/ast/visitor.ts:322

  #### Parameters

  - ##### context: Context

  #### Returns void

### triggerOperationAfter

- triggerOperationAfter(context: Context): void

- - Defined in src/ast/visitor.ts:346

  #### Parameters

  - ##### context: Context

  #### Returns void

### triggerOperationBefore

- triggerOperationBefore(context: Context): void

- - Defined in src/ast/visitor.ts:316

  #### Parameters

  - ##### context: Context

  #### Returns void

### triggerOperationsAfter

- triggerOperationsAfter(context: Context): void

- - Defined in src/ast/visitor.ts:352

  #### Parameters

  - ##### context: Context

  #### Returns void

### triggerOperationsBefore

- triggerOperationsBefore(context: Context): void

- - Defined in src/ast/visitor.ts:310

  #### Parameters

  - ##### context: Context

  #### Returns void

### triggerRole

- triggerRole(context: Context): void

- - Defined in src/ast/visitor.ts:304

  #### Parameters

  - ##### context: Context

  #### Returns void

### triggerRoleAfter

- triggerRoleAfter(context: Context): void

- - Defined in src/ast/visitor.ts:364

  #### Parameters

  - ##### context: Context

  #### Returns void

### triggerRoleBefore

- triggerRoleBefore(context: Context): void

- - Defined in src/ast/visitor.ts:298

  #### Parameters

  - ##### context: Context

  #### Returns void

### triggerRolesAfter

- triggerRolesAfter(context: Context): void

- - Defined in src/ast/visitor.ts:370

  #### Parameters

  - ##### context: Context

  #### Returns void

### triggerRolesBefore

- triggerRolesBefore(context: Context): void

- - Defined in src/ast/visitor.ts:292

  #### Parameters

  - ##### context: Context

  #### Returns void

### visitAllOperationsAfter

- visitAllOperationsAfter(context: Context): void

- Implementation of Visitor.visitAllOperationsAfter

  - Defined in src/ast/visitor.ts:373

  #### Parameters

  - ##### context: Context

  #### Returns void

### visitAllOperationsBefore

- visitAllOperationsBefore(context: Context): void

- Implementation of Visitor.visitAllOperationsBefore

  - Defined in src/ast/visitor.ts:271

  #### Parameters

  - ##### context: Context

  #### Returns void

### visitArgument

- visitArgument(context: Context): void

- Implementation of Visitor.visitArgument

  - Defined in src/ast/visitor.ts:331

  #### Parameters

  - ##### context: Context

  #### Returns void

### visitArgumentsAfter

- visitArgumentsAfter(context: Context): void

- Implementation of Visitor.visitArgumentsAfter

  - Defined in src/ast/visitor.ts:337

  #### Parameters

  - ##### context: Context

  #### Returns void

### visitArgumentsBefore

- visitArgumentsBefore(context: Context): void

- Implementation of Visitor.visitArgumentsBefore

  - Defined in src/ast/visitor.ts:325

  #### Parameters

  - ##### context: Context

  #### Returns void

### visitDocumentAfter

- visitDocumentAfter(context: Context): void

- Implementation of Visitor.visitDocumentAfter

  - Defined in src/ast/visitor.ts:466

  #### Parameters

  - ##### context: Context

  #### Returns void

### visitDocumentBefore

- visitDocumentBefore(context: Context): void

- Implementation of Visitor.visitDocumentBefore

  - Defined in src/ast/visitor.ts:258

  #### Parameters

  - ##### context: Context

  #### Returns void

### visitEnum

- visitEnum(context: Context): void

- Implementation of Visitor.visitEnum

  - Defined in src/ast/visitor.ts:435

  #### Parameters

  - ##### context: Context

  #### Returns void

### visitEnumValue

- visitEnumValue(context: Context): void

- Implementation of Visitor.visitEnumValue

  - Defined in src/ast/visitor.ts:447

  #### Parameters

  - ##### context: Context

  #### Returns void

### visitEnumValuesAfter

- visitEnumValuesAfter(context: Context): void

- Implementation of Visitor.visitEnumValuesAfter

  - Defined in src/ast/visitor.ts:453

  #### Parameters

  - ##### context: Context

  #### Returns void

### visitEnumValuesBefore

- visitEnumValuesBefore(context: Context): void

- Implementation of Visitor.visitEnumValuesBefore

  - Defined in src/ast/visitor.ts:441

  #### Parameters

  - ##### context: Context

  #### Returns void

### visitEnumsAfter

- visitEnumsAfter(context: Context): void

- Implementation of Visitor.visitEnumsAfter

  - Defined in src/ast/visitor.ts:459

  #### Parameters

  - ##### context: Context

  #### Returns void

### visitEnumsBefore

- visitEnumsBefore(context: Context): void

- Implementation of Visitor.visitEnumsBefore

  - Defined in src/ast/visitor.ts:429

  #### Parameters

  - ##### context: Context

  #### Returns void

### visitInterface

- visitInterface(context: Context): void

- Implementation of Visitor.visitInterface

  - Defined in src/ast/visitor.ts:283

  #### Parameters

  - ##### context: Context

  #### Returns void

### visitInterfaceAfter

- visitInterfaceAfter(context: Context): void

- Implementation of Visitor.visitInterfaceAfter

  - Defined in src/ast/visitor.ts:355

  #### Parameters

  - ##### context: Context

  #### Returns void

### visitInterfaceBefore

- visitInterfaceBefore(context: Context): void

- Implementation of Visitor.visitInterfaceBefore

  - Defined in src/ast/visitor.ts:277

  #### Parameters

  - ##### context: Context

  #### Returns void

### visitNamespace

- visitNamespace(context: Context): void

- Implementation of Visitor.visitNamespace

  - Defined in src/ast/visitor.ts:264

  #### Parameters

  - ##### context: Context

  #### Returns void

### visitObject

- visitObject(context: Context): void

- Implementation of Visitor.visitObject

  - Defined in src/ast/visitor.ts:392

  #### Parameters

  - ##### context: Context

  #### Returns void

### visitObjectAfter

- visitObjectAfter(context: Context): void

- Implementation of Visitor.visitObjectAfter

  - Defined in src/ast/visitor.ts:416

  #### Parameters

  - ##### context: Context

  #### Returns void

### visitObjectBefore

- visitObjectBefore(context: Context): void

- Implementation of Visitor.visitObjectBefore

  - Defined in src/ast/visitor.ts:386

  #### Parameters

  - ##### context: Context

  #### Returns void

### visitObjectField

- visitObjectField(context: Context): void

- Implementation of Visitor.visitObjectField

  - Defined in src/ast/visitor.ts:404

  #### Parameters

  - ##### context: Context

  #### Returns void

### visitObjectFieldsAfter

- visitObjectFieldsAfter(context: Context): void

- Implementation of Visitor.visitObjectFieldsAfter

  - Defined in src/ast/visitor.ts:410

  #### Parameters

  - ##### context: Context

  #### Returns void

### visitObjectFieldsBefore

- visitObjectFieldsBefore(context: Context): void

- Implementation of Visitor.visitObjectFieldsBefore

  - Defined in src/ast/visitor.ts:398

  #### Parameters

  - ##### context: Context

  #### Returns void

### visitObjectsAfter

- visitObjectsAfter(context: Context): void

- Implementation of Visitor.visitObjectsAfter

  - Defined in src/ast/visitor.ts:422

  #### Parameters

  - ##### context: Context

  #### Returns void

### visitObjectsBefore

- visitObjectsBefore(context: Context): void

- Implementation of Visitor.visitObjectsBefore

  - Defined in src/ast/visitor.ts:380

  #### Parameters

  - ##### context: Context

  #### Returns void

### visitOperation

- visitOperation(context: Context): void

- Implementation of Visitor.visitOperation

  - Defined in src/ast/visitor.ts:319

  #### Parameters

  - ##### context: Context

  #### Returns void

### visitOperationAfter

- visitOperationAfter(context: Context): void

- Implementation of Visitor.visitOperationAfter

  - Defined in src/ast/visitor.ts:343

  #### Parameters

  - ##### context: Context

  #### Returns void

### visitOperationBefore

- visitOperationBefore(context: Context): void

- Implementation of Visitor.visitOperationBefore

  - Defined in src/ast/visitor.ts:313

  #### Parameters

  - ##### context: Context

  #### Returns void

### visitOperationsAfter

- visitOperationsAfter(context: Context): void

- Implementation of Visitor.visitOperationsAfter

  - Defined in src/ast/visitor.ts:349

  #### Parameters

  - ##### context: Context

  #### Returns void

### visitOperationsBefore

- visitOperationsBefore(context: Context): void

- Implementation of Visitor.visitOperationsBefore

  - Defined in src/ast/visitor.ts:307

  #### Parameters

  - ##### context: Context

  #### Returns void

### visitRole

- visitRole(context: Context): void

- Implementation of Visitor.visitRole

  - Defined in src/ast/visitor.ts:301

  #### Parameters

  - ##### context: Context

  #### Returns void

### visitRoleAfter

- visitRoleAfter(context: Context): void

- Implementation of Visitor.visitRoleAfter

  - Defined in src/ast/visitor.ts:361

  #### Parameters

  - ##### context: Context

  #### Returns void

### visitRoleBefore

- visitRoleBefore(context: Context): void

- Implementation of Visitor.visitRoleBefore

  - Defined in src/ast/visitor.ts:295

  #### Parameters

  - ##### context: Context

  #### Returns void

### visitRolesAfter

- visitRolesAfter(context: Context): void

- Implementation of Visitor.visitRolesAfter

  - Defined in src/ast/visitor.ts:367

  #### Parameters

  - ##### context: Context

  #### Returns void

### visitRolesBefore

- visitRolesBefore(context: Context): void

- Implementation of Visitor.visitRolesBefore

  - Defined in src/ast/visitor.ts:289

  #### Parameters

  - ##### context: Context

  #### Returns void

Generated using TypeDoc